function [X PH] = SF_fft_analysis(x,L,FFT_size,S)
%x: signal to be decomposed
%L: Window length (in samples)
%S: Window advance
%
%X: STFT
 
w = hamming2(L,S);
%  w = hamming(L); 
T = length(x);

M = floor((T-L)/S+1);

X = zeros(FFT_size,M);
X_aux = zeros(FFT_size,M);
PH = zeros(FFT_size,M);

x = x(:);
w = w(:);
 
 
for m = 0:M-1
    X_aux(:,m+1) = fft(x(1+m*S:m*S+L).*w,FFT_size);
		X(:,m+1) = X_aux(:,m+1);
		PH(:,m+1) = phase(X_aux(:,m+1));
end
 
 
 
end

