close all;
%  	PHI = [10 20 10 20 48 72];

for k = 1:1
	

% sinal.name = 'piano_sinal_1';
% sinal.D = 1;
% sinal.tau = 5;
% sinal.phi = 10;


sinal.name = 'piano_trumpet_t';
sinal.D = 2;
sinal.tau = 3;
sinal.phi = 10;

		tic

error = zeros(5,1);
SDR  = zeros(5,1);
PEAQ = zeros(5,1);

W = 0;
H = 0;
processing = {'ifft','wiener','cross','bin_mask','mask'};
for proc = 1:5 
	
	processing{proc}
	[error(proc) SDR(proc) PEAQ(proc)] = SoundFact_main(sinal.name, ...
	'analysis','fft', ...
	'load_analysis','yes',...
	'load_fact','yes',...
	'obj_func','kld',...
	'processing',processing{proc},...    
	'synthesis','ifft',...
	'fmin',220,...
	'b',24,'d',sinal.D,'phi',sinal.phi,'tau',sinal.tau,'max_it',500,'delta',10e-5,...
	'out_name',['out_LNMF2D_',processing{proc},],...
	'WS',512,'FFT_size',1024,'S',256,'hopsize', 128/4,...
	'disp_targ','off','disp_plot','on','disp_all','off',...
	'bss_eval','yes','spectral_adaptation','off',...
    'W_ini',W,'H_ini',H);

	close all

    load(['../audio_in/',sinal.name,'/',sinal.name,'_lnmf2d_kld.mat']);
	
	save test_QA_proc error SDR PEAQ
	
end

subplot(3,1,1)
plot(error)
title('Erro de Reconstruo (KLD)')
subplot(3,1,2)
plot(SDR)
title('SDR')
subplot(3,1,3)
plot(PEAQ)
title('PEAQ')



	toc


end


