close all;
clear all;
%  	PHI = [10 20 10 20 48 72];
	

% tested
%    name = 'flute_perc_org'; phi = 10 ; tau = 1; d = 3;
%  	name = 'flute_perc' ; tau = 3; phi = 10; d = 2 ;
%  	name = 'piano_trumpet_t'; phi = 10 ; tau = 2; d = 2;
%  	name = 'piano_trumpet2' ; tau = 3; phi = 10; d = 2;
%  	name = 'perc_ethnic' ; tau = 10; phi = 1; d = 2;

  	name = 'piano_sinal_1' ; tau = 5; phi = 10; d = 1;

%  	figure
%  	title(name);
%  	fprintf('\n n%i \n\n',k)
		tic

	max_it = 1000;
	
  for m_it = 0:1:20
	
		try
			algorithm = 'lnmf2d';
			obj_func = 'mse';
			load(['../audio_in/',name,'/',name,'_',algorithm,'_',obj_func,'.mat']);
		catch
			M = 0;
		end

		if(m_it <= 1), M = 0; end;

		if(m_it == 0), sa = 'off'; loa = 'no'; else, sa = 'on'; loa = 'yes'; end;

		[error SDR PEAQ SDR_match PEAQ_match] = SoundFact_main(name, ...
		'analysis','fft', ...
		'load_analysis','yes', ...
		'load_fact','yes',...
		'obj_func',obj_func,...
		'processing','ifft',...    
		'synthesis','ifft',...
		'fmin',220,...
		'b',24,'d',d,'phi',phi,'tau',tau,'max_it',max_it,'delta',10e-5,...
		'out_name',['out_M_',int2str(m_it),],...
		'WS',512,'FFT_size',1024,'S',256,'hopsize', 128/4,...
		'disp_targ','on','disp_plot','on','disp_all','off',...
		'bss_eval','yes','spectral_adaptation',sa,...
		'M_ini',M);

		error_vec(m_it+1) = error;
		PEAQ_vec(m_it+1) = PEAQ;
		SDR_vec(m_it+1) = SDR;
	
	end
	toc

figure
subplot(3,1,1)
plot(error_vec(1:20))
subplot(3,1,2)
plot(PEAQ_vec(1:20))
subplot(3,1,3)
plot(SDR_vec(1:20))

%  fprintf('\n n5 \n\n')
%    tic
%   SoundFact_main('piano_all2', ...
%   'analysis','cqt', ...
%   'load_analysis','yes',...
%   'load_fact','no',...
%   'obj_func','mse',...
%   'synthesis','ifft',...
%   'b',24,'d',1,'phi',20,'tau',1,'max_it',300,'delta',10e-4,...
%   'out_name','out',...
%   'WS',512,'FFT_size',1024,'S',128,...
%  'hopsize', 128,...
%   'disp_targ','on','disp_plot','on',...
%   'bss_eval','no')
%  toc



