close all;
clear all;


% tested
sinal(1).name = 'flute_perc_org';   sinal(1).tau = 1;  sinal(1).phi = 10; sinal(1).d = 3;
sinal(2).name = 'flute_perc' ;      sinal(2).tau = 3;  sinal(2).phi = 10; sinal(2).d = 2;
sinal(3).name = 'piano_trumpet_t';  sinal(3).tau = 2;  sinal(3).phi = 10; sinal(3).d = 2;
sinal(4).name = 'piano_trumpet2' ;  sinal(4).tau = 3;  sinal(4).phi = 10; sinal(4).d = 2;
sinal(5).name = 'piano_flute' ;  		sinal(5).tau = 3;  sinal(5).phi = 16; sinal(5).d = 2;
%  sinal(6).name = 'piano_sinal_1' ; sinal(6).tau = 5;  sinal(6).phi = 10; sinal(6).d = 1;
%  sinal(7).name = 'trumpet_sinal_1' ; sinal(7).tau = 5;  sinal(7).phi = 10; sinal(7).d = 1;



%  sinal(7).name = 'piano_flute_str' ; sinal(7).tau = 3;  sinal(7).phi = 16; sinal(7).d = 3;
%sinal(5).name = 'perc_ethnic' ;     sinal(5).tau = 10; sinal(5).phi = 1;  sinal(5).d = 2;


max_it = 1000;
R = 50;

analysis = {'fft','fft2log'};
obj_func = {'kld'};

tic
%  k = 1;
%  fid = fopen(['NMF2D_LNMF2D_table_',sinal(k).name,'.tex'],'w');

N_si = length(sinal)

result = cell(N_si);
parfor si = 1:N_si

sinal_aux = 0;
sinal_aux.SDR = zeros(length(analysis),length(obj_func),sinal(si).d,R);
sinal_aux.PEAQ = -5*ones(length(analysis),length(obj_func),sinal(si).d,R);
sinal_aux.semente = zeros(length(analysis),length(obj_func),R); 

    for ai = 1:2
				sinal_aux.not_conv(ai) = 0;	
        for oi = 1%1:2	
					for repets = 1:R
%                          load('seed_matrix')
%                          if(seed_matrix(ai,si,oi) ~= 0)
%                              rand('state',seed_matrix(ai,si,oi));
%                          else


%                          end
							convergence = 0;
%  							trials = 1;
							while(convergence ~= 1)

								seed = 100*sum(clock);
								rand('state',seed);
								sinal_aux.semente(ai,oi,repets) = seed;

								disp(['##########',sinal(si).name,'#',num2str(repets),'#',analysis{ai},'#####################'])
								[error SDR PEAQ SDR_match PEAQ_match] = SoundFact_main(sinal(si).name, ...
										'analysis',analysis{ai}, ...
										'load_analysis','no', ...
										'load_fact','no',...
										'obj_func',obj_func{oi},...
										'processing','wiener',...    
										'synthesis','ifft',...
										'fmin',50,...
										'b',24,'d',sinal(si).d,'phi',sinal(si).phi,'tau',sinal(si).tau,'max_it',max_it,'delta',10e-5,...
										'out_name',[sinal(si).name,'_',analysis{ai},'_',obj_func{oi}],...
										'WS',512,'FFT_size',1024,'S',128,'hopsize', 128/4,...
										'disp_targ','off','disp_plot','off','disp_all','off',...
										'bss_eval','yes','spectral_adaptation','off'); 
								close all;
%  								if (sum(round(SDR*100)/100) > sum(sinal_aux.SDR(ai,oi,:)))
									sinal_aux.SDR(ai,oi,:,repets) = round(SDR*100)/100;  
									sinal_aux.PEAQ(ai,oi,:,repets) = round(PEAQ*100)/100;
%  								end
																
								if((norm(SDR_match-PEAQ_match) == 0) && (sum(SDR_match(:,2)) == sum(1:sinal(si).d)) && (sum(SDR < 0) == 0) && (sum(PEAQ == -5) == 0) ) % || (trials > 4) 
									convergence = 1;
								else
									sinal_aux.not_conv(ai) = sinal_aux.not_conv(ai) + 1;
									disp(['*************Match tables inconsistent... triyng again**********',sinal(si).name,'#',num2str(repets),'#',analysis{ai},'**'])
%  									trials = trials+1;
								end
							end %while
						end %for repets
        end %for oi
    end %for ai

		result{si} = sinal_aux;
%  		save xx sinal_aux
%  		clear(sinal_aux);
%      for d = 1:sinal(si).d
%      fprintf(fid,strrep(strrep(['\\texttt{',strrep(sinal(si),'_','\\_'),'.wav}&',num2str(sinal_aux.SDR(2,1,d)),...
%                                             '& ',num2str(sinal_aux.SDR(1,1,d)),...
%                                             '& ',num2str(sinal_aux.PEAQ(2,1,d)),...
%                                             '& ',num2str(sinal_aux.PEAQ(1,1,d)),...	                                           
%                                             '\\\\ \\hline \n'],'.',','),',wav','.wav'));
%      end
    
%      for d = 1:sinal(si).d
%      fprintf(fid,strrep(strrep(['\\texttt{',strrep(sinal(si),'_','\\_'),'.wav}&',num2str(sinal_aux.SDR(2,2,d)),' & ',num2str(sinal_aux.SDR(2,1,d)),...
%                                             '& ',num2str(sinal_aux.PEAQ(2,2,d)),'& ',num2str(sinal_aux.PEAQ(2,1,d)),...
%                                             '& ',num2str(sinal_aux.SDR(1,2,d)),' & ',num2str(sinal_aux.SDR(1,1,d)),...
%                                             '& ',num2str(sinal_aux.PEAQ(1,2,d)),'& ',num2str(sinal_aux.PEAQ(1,1,d)),...	                                           
%                                             '\\\\ \\hline \n'],'.',','),',wav','.wav'));
%      end
end %for si

save sim_NMF2D_LNMF2D_result result
toc

%  fclose(fid)


