%  test.audio_in = 'flute_perc';
%  test.d = 2;
%  test.phi = 10;
%  
%  test.audio_in = 'flute_perc_org';
%  test.d = 3;
%  test.phi = 10;
%  
%  test.audio_in = 'piano_flute';
%  test.d = 2;
%  test.phi = 12;
%  
test.audio_in = 'piano_trumpet2';
test.d = 2;
test.phi = 10;
test.tau = {2};
%  
%  test.audio_in = 'piano_flute_str';
%  test.d = 3;
%  test.phi = 14;

%  test.audio_in = 'piano_trumpet_t';
%  test.d = 2;
%  test.phi = 10;



analysis_opt ={'fft','fft2log','cqt'};
obj_func_opt = {'kld', 'mse'};
process_opt = {'ifft', 'mask', 'cross', 'wiener','bin_mask'};
synth_opt = {'ifft', 'gl', 'rtisi', 'rtisi-la','misi'};

%  test.tau = {3,7,11};
test.delta = 10e-6;
test.max_it = 1000;
test.hopsize = 5;


test.WS = 512;
test.S = 128;
test.FFT_size = 1024;

test.disp_targ = 'off';
test.disp_plot = 'on';

test.load_analysis = 'no';
test.load_fact = 'no';
test.adapt = 'on';

test.bss_eval =  'yes';



%  analysis_opt ={'fft','cqt','fft2log'};
%  obj_func_opt = {'kld', 'mse'};
%  synth_opt = {'ifft', 'mask', 'can','cross', 'wiener','bin_mask'};

%  fid = fopen('BSS_eval_results2.csv','w');
%  fprintf(fid,'outname, Separated, Source, SDR, SIR, SAR\n');
%  fclose(fid);


for k = 1:length(analysis_opt)
for n = 1:length(test.tau);

    test.analysis = analysis_opt{k};
    for l = 1:length(obj_func_opt);
        test.obj_func = obj_func_opt{l};

%          for m = 1:length(synth_opt);
        for m = 1:1;

            test.synth = synth_opt{m};
            test.process = process_opt{4};%wiener

            disp(test.analysis);
            disp(test.obj_func);
            disp(test.process);
            disp(test.synth);
						
            outname = sprintf('out%d_%s_%s_%s',test.tau{n},test.analysis,test.obj_func,test.synth);
						if (l == 1)&&(m == 1) test.load_analysis = 'no';, else test.load_analysis = 'yes';, end
				    if (m == 1) test.load_fact = 'no';test.adapt = 'load'; , else test.load_fact = 'yes';test.adapt = 'on';, end
                    
%                     test.load_analysis 
%                     test.load_fact
%                     pause;

        try


tic
SoundFact_main(test.audio_in, ...
'analysis',test.analysis, ...
'obj_func',test.obj_func,...
'processing',test.process,'synthesis',test.synth,...
'd',test.d,'phi',test.phi,'tau',test.tau{n},'max_it',test.max_it,'delta',test.delta,...
'out_name',outname,...
'WS',test.WS,'S',test.S,'FFT_size',test.FFT_size,...
'disp_targ',test.disp_targ,'disp_plot',test.disp_plot,...
'load_analysis', test.load_analysis,'load_fact', test.load_fact,'spectral_adaptation',test.adapt,...
'hopsize',test.hopsize,...
'bss_eval',test.bss_eval);
toc

        catch
						[a b] = lasterr;
            fprintf('********%s\n',a);
            fprintf('********%s\n',b);

        end
            end
        end
    end
end  
       
