function SF_fast_cqt_synth2(Y,hopsize,Fs,Nb,out_pathname,FFT_T)

FFT_XX_hat = FFT_T.' * Y;

FFT_XX_hat = FFT_XX_hat + FFT_XX_hat(end:-1:1,:);

XX_hat = ifft(FFT_XX_hat,[],1);

%imagesc(abs(XX_hat))
%pause;


nframes = size(XX_hat,2);
maxWsize =  size(XX_hat,1);

x_hat = zeros(maxWsize + (nframes-1)*hopsize,1);

size(x_hat)
k = 1;
for n = 1:size(XX_hat,2)
	x_hat(k:k+maxWsize-1) = x_hat(k:k+maxWsize-1) + real(XX_hat(:,n));
	k = k + hopsize;
end	

%plot(1:32000,x,'g',1:32000,.5+x_hat,'r')

x_hat = x_hat/max(abs(x_hat));

name = sprintf('inv_cqt4k_%d.wav',hopsize);

wavwrite(.9*x_hat, Fs,Nb,out_pathname);

end