function x = SF_fft_synth(X,L,S)
%function x = iSTFT(X,L,S,M,T)
%X: spectrogram
%L: Window length (in samples)
%S: Window advance
%
%x: signal
 
%  L = size(X,1);
w = hamming2(L,S);
w = w(:);
M = size(X,2); 
T = L+(M-1)*S;

x = zeros(T,1);
 
for m = 0:M-1
		aux = real((ifft(X(:,m+1))));

%  		plot(aux)
%  		pause;

    x(1+m*S:m*S+L) = x(1+m*S:m*S+L) + aux(1:L);
end

end


%  function y = SF_fft_synth(X,L,S)
%  
%  % SF_fft_synth(X,Ws,out_pathname,Fs,Nb)
%  %
%  % Performs an ifft on a spectrogram, using post-window .
%  % 
%  % INPUT
%  % X: Linear full spectrogram, expected to have phase
%  % Ws: Window Size
%  % FFT_size: Size o the FFT, which is the number of freq. bins
%  % out_pathname: name and path for the output signal
%  % Fs: Sample rate
%  % Nb: number of bits
%  %
%  % Author: Alan F. Tygel
%  % Last Modified: 09/02/2009
%   
%  M = size(X,2);
%  window = hamming2(L,S);
%  y = zeros(M*S+L-S,1);
%  
%  %  scale = mean(window.^2)*L/S;
%  
%  H = L/S;
%  
%  if(H == 2)
%  	gain_comp = zeros(L/2,1);
%  	for k=1:L/2
%  		for h = 0:H/2
%  			gain_comp(k) = gain_comp(k) + window(k+h*S)^2;
%  		end
%  	end
%  else
%  	gain_comp = mean(window.^2)*L/S;
%  end
%  
%  
%  k = 1; % init index of start of frame
%  for m=1:M % for every frame
%     % ifft, window, overlap-add
%  %     y(i:i+L-1) = y(i:i+L-1) + real(ifft(X(:,f))).*window/scale; 
%  	 aux = real(ifft(X(:,m)));
%     y(k:k+L-1) = y(k:k+L-1) + aux(1:L).*window; 
%  	 y(k:k+L/2-1) = y(k:k+L/2-1) ./gain_comp;
%     k = k + S;
%  end