close all


x_orig = wavread('../audio_in/piano_flute/piano_flute_s2.wav');
x_ifft = wavread('../audio_out/piano_flute/piano_flute_fft_ifft_1.wav');
x_rtisi = wavread('../audio_out/piano_flute/piano_flute_fft_rtisi_1.wav');
x_rtisi_la = wavread('../audio_out/piano_flute/piano_flute_fft_rtisi-la_1.wav');

figure
subplot(4,1,1)
plot(x_orig)
title('Original')

subplot(4,1,2)
plot(x_ifft)
title('fase original')

subplot(4,1,3)
plot(x_rtisi)
title('RTISI')

subplot(4,1,4)
plot(x_rtisi_la)
title('RTISI-LA')


figure
hold on
plot(x_rtisi,'r')
plot(x_ifft+1)
legend('RTISI','fase original')
hold off

figure
hold on
plot(x_rtisi,'r')
plot(x_ifft)
legend('RTISI','fase original')
hold off


figure
hold on
plot(x_orig,'r')
plot(x_ifft)
legend('Original','fase original')
hold off