close all;
clear all;


% tested
sinal(1).name = 'flute_perc_org';   sinal(1).tau = 1;  sinal(1).phi = 10; sinal(1).d = 3; 
sinal(2).name = 'flute_perc' ;      sinal(2).tau = 3;  sinal(2).phi = 10; sinal(2).d = 2;	
sinal(3).name = 'piano_trumpet_t';  sinal(3).tau = 2;  sinal(3).phi = 10; sinal(3).d = 2;
sinal(4).name = 'piano_trumpet2' ;  sinal(4).tau = 3;  sinal(4).phi = 10; sinal(4).d = 2;
sinal(5).name = 'piano_flute' ;  		sinal(5).tau = 3;  sinal(5).phi = 16; sinal(5).d = 2;
%  sinal(6).name = 'piano_sinal_1' ; sinal(6).tau = 5;  sinal(6).phi = 10; sinal(6).d = 1;
%  sinal(7).name = 'trumpet_sinal_1' ; sinal(7).tau = 5;  sinal(7).phi = 10; sinal(7).d = 1;


load /home/alan/Mestrado/Tese/SoundFact2/mfiles/sim_NMF2D_LNMF2D_result
sinal_res = result;

max_it = 1000;

analysis = {'fft','fft2log'};
obj_func = {'kld'};

tic

N_si = length(sinal)
M_result = cell(N_si);


parfor si = 1:N_si

	M_SDR = zeros(length(analysis),length(obj_func),sinal(si).d);
	M_PEAQ = zeros(length(analysis),length(obj_func),sinal(si).d);

    for ai = 1:2
        for oi = 1%1:2	
%  
					aux = zeros(size(sinal_res{si}.SDR,3),size(sinal_res{si}.SDR,4));
					aux(:,:) = sinal_res{si}.SDR(ai,oi,:,:);
					[dummy max_ind] = max(sum(aux,1));
					rand('state',sinal_res{si}.semente(ai,oi,max_ind));


					disp(['##########',sinal(si).name,'##',analysis{ai},'#####################'])
					[error SDR PEAQ SDR_match PEAQ_match] = SoundFact_main(sinal(si).name, ...
							'analysis',analysis{ai}, ...
							'load_analysis','no', ...
							'load_fact','no',...
							'obj_func',obj_func{oi},...
							'processing','wiener',...    
							'synthesis','ifft',...
							'fmin',50,...
							'b',24,'d',sinal(si).d,'phi',sinal(si).phi,'tau',sinal(si).tau,'max_it',max_it,'delta',10e-5,...
							'out_name',[sinal(si).name,'_',analysis{ai},'_',obj_func{oi}],...
							'WS',512,'FFT_size',1024,'S',256,'hopsize', 128/4,...
							'disp_targ','off','disp_plot','off','disp_all','off',...
							'bss_eval','yes','spectral_adaptation','on'); 
							close all;
							M_SDR(ai,oi,:) = round(SDR*100)/100;  
							M_PEAQ(ai,oi,:) = round(PEAQ*100)/100;
																
        end %for oi
    end %for ai
		M_result{si}.M_SDR = M_SDR;
		M_result{si}.M_PEAQ = M_PEAQ; 
end %for si


save sim_M_result M_result
toc

%  fclose(fid)


