close all;
clear all;


% tested
%  sinal(1).name = 'flute_perc_org';   sinal(1).tau = 1;  sinal(1).phi = 10; sinal(1).d = 3;
%  sinal(2).name = 'flute_perc' ;      sinal(2).tau = 3;  sinal(2).phi = 10; sinal(2).d = 2;
%  sinal(3).name = 'piano_trumpet_t';  sinal(3).tau = 2;  sinal(3).phi = 10; sinal(3).d = 2;
%  sinal(4).name = 'piano_trumpet2' ;  sinal(4).tau = 3;  sinal(4).phi = 10; sinal(4).d = 2;
%  sinal(5).name = 'piano_flute' ;  		sinal(5).tau = 3;  sinal(5).phi = 16; sinal(5).d = 2;
%  sinal(6).name = 'piano_sinal_1' ; sinal(6).tau = 5;  sinal(6).phi = 10; sinal(6).d = 1;
sinal(7).name = 'trumpet_sinal_1' ; sinal(7).tau = 5;  sinal(7).phi = 10; sinal(7).d = 1;



%  sinal(7).name = 'piano_flute_str' ; sinal(7).tau = 3;  sinal(7).phi = 16; sinal(7).d = 3;
%sinal(5).name = 'perc_ethnic' ;     sinal(5).tau = 10; sinal(5).phi = 1;  sinal(5).d = 2;

si = 7;
max_it = 1000;
R = 50;

analysis = {'fft','fft2log'};
obj_func = {'kld'};

tic

result = cell(1);

sinal_aux = 0;
SDR_vec = zeros(length(analysis),length(obj_func),sinal(si).d,R);
PEAQ_vec = -5*ones(length(analysis),length(obj_func),sinal(si).d,R);
semente = zeros(length(analysis),length(obj_func),R);
not_conv = zeros(length(analysis),1); 
    for ai = 1:2
        for oi = 1%1:2	
					parfor repets = 1:R

%                          end
%  							convergence = 0;
%  							trials = 1;
%  							while(convergence ~= 1)

								seed = 1e6*sum(clock);
								rand('state',seed);
								semente(ai,oi,repets) = seed;

								disp(['##########',sinal(si).name,'#',num2str(repets),'#',analysis{ai},'#####################'])
								[error SDR PEAQ SDR_match PEAQ_match] = SoundFact_main(sinal(si).name, ...
										'analysis',analysis{ai}, ...
										'load_analysis','no', ...
										'load_fact','no',...
										'obj_func',obj_func{oi},...
										'processing','wiener',...    
										'synthesis','ifft',...
										'fmin',50,...
										'b',24,'d',sinal(si).d,'phi',sinal(si).phi,'tau',sinal(si).tau,'max_it',max_it,'delta',10e-5,...
										'out_name',[sinal(si).name,'_',analysis{ai},'_',obj_func{oi},'_',num2str(repets)],...
										'WS',512,'FFT_size',1024,'S',256,'hopsize', 128/4,...
										'disp_targ','off','disp_plot','off','disp_all','off',...
										'bss_eval','yes','spectral_adaptation','off'); 
								close all;
									SDR_vec(ai,oi,:,repets) = round(SDR*100)/100;  
									PEAQ_vec(ai,oi,:,repets) = round(PEAQ*100)/100;
																
%  								if((norm(SDR_match-PEAQ_match) == 0) && (sum(SDR_match(:,2)) == sum(1:sinal(si).d)) && (sum(SDR < 0) == 0) && (sum(PEAQ == -5) == 0) )  
%  									convergence = 1;
%  								else
%  									disp(['*************Match tables inconsistent... triyng again**********',sinal(si).name,'#',num2str(repets),'#',analysis{ai},'**'])
%  								end
%  							end %while
						end %for repets
        end %for oi
    end %for ai

	result{si}.SDR = SDR_vec;
	result{si}.PEAQ = PEAQ_vec;
	result{si}.semente = semente;
	result{si}.not_conv = not_conv;
	
save sim_NMF2D_LNMF2D_trumpet1 result
toc

%  fclose(fid)


