close all;
clear all;


% tested
sinal(1).name = 'flute_perc_org';   sinal(1).tau = 1;  sinal(1).phi = 10; sinal(1).d = 3; 
sinal(2).name = 'flute_perc' ;      sinal(2).tau = 3;  sinal(2).phi = 10; sinal(2).d = 2;	
sinal(3).name = 'piano_trumpet_t';  sinal(3).tau = 2;  sinal(3).phi = 10; sinal(3).d = 2;
sinal(4).name = 'piano_trumpet2' ;  sinal(4).tau = 3;  sinal(4).phi = 10; sinal(4).d = 2;
sinal(5).name = 'piano_flute' ;  		sinal(5).tau = 3;  sinal(5).phi = 16; sinal(5).d = 2;
%  sinal(6).name = 'piano_sinal_1' ; sinal(6).tau = 5;  sinal(6).phi = 10; sinal(6).d = 1;
%  sinal(7).name = 'trumpet_sinal_1' ; sinal(7).tau = 5;  sinal(7).phi = 10; sinal(7).d = 1;


load /home/alan/Mestrado/Tese/SoundFact2/mfiles/sim_NMF2D_LNMF2D_result
sinal_res = result;

analysis = {'fft','fft2log'};
obj_func = {'kld'};
synth = {'gl','rtisi','rtisi-la','misi','ifft'};

tic

N_si = length(sinal)
Synth_result = cell(N_si);
ai = 1;
oi = 1;


parfor si = 1:5%1:N_si

	Synth_SDR = zeros(length(analysis),length(synth),sinal(si).d);
	Synth_PEAQ = zeros(length(analysis),length(synth),sinal(si).d);

    for synth_i = 1:5
%  
					aux = zeros(size(sinal_res{si}.SDR,3),size(sinal_res{si}.SDR,4));
					aux(:,:) = sinal_res{si}.SDR(ai,oi,:,:);
					[dummy max_ind] = max(sum(aux,1));
					rand('state',sinal_res{si}.semente(ai,oi,max_ind));


					disp(['##########',sinal(si).name,'##',analysis{ai},'##########',synth{synth_i},'##########'])
					[error SDR PEAQ SDR_match PEAQ_match] = SoundFact_main(sinal(si).name, ...
							'analysis',analysis{ai}, ...
							'load_analysis','no', ...
							'load_fact','no',...
							'obj_func',obj_func{oi},...
							'processing','wiener',...    
							'synthesis',synth{synth_i},...
							'fmin',50,...
							'b',24,'d',sinal(si).d,'phi',sinal(si).phi,'tau',sinal(si).tau,'max_it',1000,'delta',10e-5,...
							'out_name',[sinal(si).name,'_',analysis{ai},'_',synth{synth_i}],...
							'WS',512,'FFT_size',1024,'S',128,'hopsize', 128/4,...
							'disp_targ','off','disp_plot','off','disp_all','off',...
							'bss_eval','yes','spectral_adaptation','off'); 
							close all;
							Synth_SDR(ai,synth_i,:) = round(SDR*100)/100;  
							Synth_PEAQ(ai,synth_i,:) = round(PEAQ*100)/100;
																
    end %for synth_i
		Synth_result{si}.Synth_SDR = Synth_SDR;
		Synth_result{si}.Synth_PEAQ = Synth_PEAQ; 
end %for si


save sim_Synth_result Synth_result
toc

%  fclose(fid)


